#!/usr/bin/env python
# coding: utf8
# ------------------------------------------------------------------------------------
# python 2.7.10 and pyserial2.7
# HW: 
# FOTEMP-FTMS with four modules (RS232)
# Modules: 
# slot 1: 4ch+display
# slot 2: none
# slot 3: 2ch+display
# slot 4: 1ch+display
# slot 5: 4ch (no display)
# ------------------------------------------------------------------------------------
# TEST SETTINGS ...
COMPORT = 'COM8'
COMPORT_TIMEOUT = 1			# in seconds
COMPORT_SPEED = 57600		# in baud
# ------------------------------------------------------------------------------------
import serial,time
from datetime import datetime
DEBUG=0
#DEBUG=1

def get_temp(ser,address):
	rc1=""
	ser.write("A0"+str(address)+" ?02\r\n")
	rc1 =ser.readline()
	rc1+=ser.readline()
	if DEBUG==1: print "rc1="+rc1
	rc2=rc1.split('\r')[0]
	if DEBUG==1: print "rc2="+rc2
	rc3=rc2.split(' ')
	if DEBUG==1: print "rc3="+str(rc3)
	return rc3[1:]

def get_id_addr(ser,address):
	rc1=""
	ser.write("A0"+str(address)+" ?41\r\n")
	rc1 =ser.readline()
	rc1+=ser.readline()
	if DEBUG==1: print "rc1="+rc1
	rc2=rc1.split('\n')
	if DEBUG==1: print "rc2="+str(rc2)
	rc3=rc2[0].replace('\r','')
	rc3=rc3.replace("#41",'')
	rc3=rc3.replace("A0"+str(address),'')
	rc3=rc3.replace(' ','')
	rc3=rc3.replace('3','')
	if DEBUG==1: print "rc3="+str(rc3)
	return rc3

if __name__ == "__main__":
	print "*start at "+datetime.now().strftime('%Y-%m-%d %H:%M:%S.%f')
	ser = serial.Serial(COMPORT, COMPORT_SPEED, timeout=COMPORT_TIMEOUT)
	print "*used com port: ",ser.name
	slots=[1,3,4,5]
	for i in slots:
		print "*dev_id"+str(i)+"="+get_id_addr(ser,i)
		time.sleep(0.5) #sec
	while 1:
		for i in slots:
			s=datetime.now().strftime('%Y-%m-%d %H:%M:%S.%f')
			temperatures=get_temp(ser,i)
			temperatures=temperatures[1:]
			for c in temperatures:
				s=s+" "+str(int(c)/10.0)
			print s
			#print s
		time.sleep(1) #sec
	#print "*done"
	#ser.close()
